<?php

namespace Modules\Role\Policies;

use Illuminate\Auth\Access\HandlesAuthorization;
use Modules\Role\Entities\Role;

class RolePolicy
{
    use HandlesAuthorization;

    /**
     * Determine whether the user can view any models.
     */
    public function viewAny($user): bool
    {
        return $user->hasPermissionTo('lihat peranan');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view($user, ?Role $role = null): bool
    {
        return $user->hasPermissionTo('lihat peranan');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create($user): bool
    {
        return $user->hasPermissionTo('tambah peranan');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update($user, ?Role $role = null): bool
    {
        return $user->hasPermissionTo('kemaskini peranan');
    }

    /**
     * Determine whether the user can delete any model.
     */
    public function deleteAny($user): bool
    {
        return $user->hasPermissionTo('hapus peranan');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete($user, ?Role $role = null): bool
    {
        return $user->hasPermissionTo('hapus peranan');
    }
}
